;;; ttc-nemurihime-tbl.el --- TT-Code (NEMURIHIME G4) data
;;; this file is created from "tc-tbl.el", of which copyright is below.

;;; tc-tbl.el --- T-Code-dependent data

;; Copyright (C) 1989--2001 Kaoru Maeda, Yasushi Saito and KITAJIMA Akira.

;; Author: Kaoru Maeda <maeda@src.ricoh.co.jp>
;;	Yasushi Saito <yasushi@is.s.u-tokyo.ac.jp>
;;      KITAJIMA Akira <kitajima@isc.osakac.ac.jp>

;; $Id: tc-tbl.el,v 1.10 2002/12/18 02:03:31 kitajima Exp $

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.

;;; Commentary:
;;
;; set following variables:
;;	tcode-input-method
;;	tcode-transparent-mode-indicator
;;	tcode-tcode-mode-indicator
;;	tcode-alnum-2byte-tcode-mode-indicator
;;	tcode-hiragana-mode-indicator
;;	tcode-katakana-mode-indicator
;;	tcode-tbl
;;	tcode-non-2-stroke-char-list
;;	tcode-another-table
;;	tcode-special-commands-alist
;;	tcode-mode-help-string
;;	tcode-stroke-file-name
;;      eelll-text

;;; Code:

(require 'tc)

(setq tcode-input-method 'ttcode)	; DO NOT CHANGE!

(setq tcode-transparent-mode-indicator "--"
      tcode-tcode-mode-indicator "TT"
      tcode-alnum-2byte-tcode-mode-indicator ""
      tcode-hiragana-mode-indicator ""
      tcode-katakana-mode-indicator "")

(setq tcode-tbl [
"* * * * * * * * * * õݤ* * Ͳ* * * * * ڿ"
"* * * * * * * * * * Ⱦյ* ױ* * * * * "
"* * * * * * * * * * ü˴Ƶѵ̷ʽ褼* * * * * Ϲ"
"* * * * * * * * * * ɸز۶찵øǹˮ񻨴* * * * * 㴳ɧ"
"* * * * * * * * * * ˿* ̩벡* * * * * * * * * * ¬컶"
"* * * * * * * * * * ܶ* * * * * 찡* * * * * ؾ˼* * * * * "
"* * * * * * * * * * ü͹* Ƚæº* ︻* * * * * "
"* * * * * * * * * * Ѿξ޽˽* * * * * ľεʻ* * * * * "
"* * * * * * * * * * ̰һ* ǵǡĢ* * * * * ð* * * * * "
"* * * * * * * * * * ɼʰζάθ§¸ܵ* * * * * ˳* * * * * "
"򰥲˷Ļú̹̳糫̵Ū"
"Ȳܰٵ쳵ͳ७ɴڲʬ饢΢ﺹեפХ"
"򹶾Ʈͼξ! Хݰƶʾ7 ( Ȥ콾⹩ȬƸ"
"°ϳӷӰ®ǽȯΩ¦ФŬ汧̾"
"Űô͵ߺٸڤʶ½򤰴夯8 ǯ򿭥"
"ħ* ɾˡϺǤ˭μΨû"
"ϸʣ* ·ǵ޸ѿݽ²۹ι˱󥩾"
"ݻɮΤ* ὨչīΥ¸ϫ򥻱ëƳǧǰƯ"
"Ǽƨ* 㸺񥣵մǶХ㻦鲿̼Ǹ"
"ٺ* * * ι̵вͥʸؼ¨"
"ѰֲɩĻž楹⤪ﲬʿ3 ȡƤҹ̹͸ÿͻ"
"԰ٳݷɳŵͺվޤԼʡ줬ڵ¢¤"
"ױشʩػ³4 ) ڳͻ5 1 ȾޥĻ"
"ڱŸʰɸʼФ6 طͽڰӡ* 0 2 "
"ݰߴ;ٸŻ׽ѹʹܤ⥷ѥܲüǤϤˤʤžȵȻĹ"
"ٹ* 꼢½ϩۤʪɬְ߿ƣͭʼ۶ʿ"
"Ἧ* źĥ͢* ήϢŴϥӱʿɻ䥴迮"
"˻ﾷ* Ű̦Źụ́Ǹ¾̿¼"
"̴* * ƶ̱̱­۴Ѹŷʸĵһδ"
"ٷ* Ʒƫ* ֶʴжʱҳ۽¼ǽĤᳰƥ"
"* * * ϼŹĮ۷ͧ´鴷ԥɱ߾ڴ% ƻ"
"* * * * ˷Ȩˬͻܰ˵ᵻ̥ƱȽͥᥦ"
"* * * * ˼Ӽ°λǮϻưƬ۹꡽ѵȤԹ"
"* * * * Υ붲Ķ־˻ľҿ9 Ҹ⽵ɰѲܻ"
"* * * * ϳ˱²̤༷̳˾Ĳپʱʡ赤䲼Գ"
"нϯ* * * * * ģץİŲϿ۾ûٶɽ޵󸱥ȥ俴պ"
"ǾϷ* * * * * ƴãǶ˺Ƥ˴ĿԻ¿ϸǷܳȺƥ͡"
"αƦ* * * * * 񼺻ʷ޲ڵ亸ֱֲɥĴݷ߽ʧ˾ķ׿"
"ؾ? * * * * * 彤±ŸٷïŽͷͤҤͿ"
"ԹȢ* * * * * ȴؿôΦȻƲʥ̱ļñȥԾȿ"
])

(setq tcode-non-2-stroke-char-list
      (mapcar (function
	       (lambda (str)
		 (tcode-string-to-char str)))
	      '("*")))

(setq tcode-another-table nil)

(setq tcode-special-commands-alist
      '(((0 0) . (lambda () (tcode-show-tables nil nil)))
					; 11 : LLɽɽ
	((0 9) . (lambda () (tcode-show-tables nil t)))
					; 10 : LRɽɽ
	((9 0) . (lambda () (tcode-show-tables t nil)))
					; 01 : RLɽɽ
	((9 9) . (lambda () (tcode-show-tables t t)))
					; 00 : RRɽɽ
	((1 1) . tcode-start-jiscode)
					; 22 : JIS ɽ
	((2 2) . tcode-toggle-alnum-mode)
					; 33 : 1-2Хڤ괹
	((2 1) . tcode-switch-variable)
					; 32 : Υȥ
	((3 3) . (lambda ()
		   (tcode-display-stroke-sequence tcode-last-help-char-list)))
					; 44 : إ
	((4 4) . (lambda () (tcode-query-stroke (point))))
					; 55 : إ
	((6 6) . tcode-bushu-begin-alternate-conversion)
					; 77 : postfix Ѵ
	((7 7) . (lambda () (tcode-transpose-strokes nil)))
					; 88 : transpose-strokes
	((8 8) . tcode-clear)
				   ; 99 : ѴʤɤΥ󥻥
	;;((26 23) . tcode-bushu-begin-conversion) ; jf : Ѵγ
	;;((25 23) . tcode-kuten)
	;;((26 22) . tcode-touten)
	;;((23 26) . tcode-mazegaki-begin-conversion)
					; fj: 򤼽Ѵ
	((7 1) . tcode-bushu-begin-alternate-conversion) ; 82 : postfix Ѵ
	((7 2) . tcode-bushu-begin-conversion) ; 83 : Ѵγ
	
	((9 8) . tcode-mazegaki-begin-alternate-conversion)
					; ֤֡դθ򤼽Ѵ
	
	;; 18פɤ1ʸθַ򤼽Ѵ
	((0 7) . (lambda ()
		   (tcode-mazegaki-convert 1 current-prefix-arg)))
	
	;; 28פɤ2ʸθַ򤼽Ѵ
	((1 7) . (lambda ()
		   (tcode-mazegaki-convert 2 current-prefix-arg)))
	
	;; 38פɤ3ʸθַ򤼽Ѵ
	((2 7) . (lambda ()
		   (tcode-mazegaki-convert 3 current-prefix-arg)))
	
	;; 48פɤ4ʸθַ򤼽Ѵ
	((3 7) . (lambda ()
		   (tcode-mazegaki-convert 4 current-prefix-arg)))
	
	;; 58פǳѤоݤȤַ򤼽Ѵ
	;;((4 7) . (lambda () (tcode-mazegaki-convert nil t)))
	;; 58פʸʤθַ򤼽Ѵ
	((4 7) . (lambda () (tcode-mazegaki-convert nil nil)))
	
	;; 29פɤ2ʸγѤоݤȤ
	;; ַ򤼽Ѵ
	((1 8) . (lambda () (tcode-mazegaki-convert 2 t)))
	
	;; 39פɤ3ʸγѤоݤȤ
	;; ַ򤼽Ѵ
	((2 8) . (lambda () (tcode-mazegaki-convert 3 t)))
	
	;; 49פɤ4ʸγѤоݤȤ
	;; ַ򤼽Ѵ
	((3 8) . (lambda () (tcode-mazegaki-convert 4 t)))
	
	;; 59פɤ5ʸγѤоݤȤ
	;; ַ򤼽Ѵ
	;;((4 8) . (lambda () (tcode-mazegaki-convert 5 t)))
	;; 59פʸʤγѤоݤȤ
	;; ַ򤼽Ѵ
	((4 8) . (lambda () (tcode-mazegaki-convert nil t)))
	))

(setq tcode-mode-help-string "\
ܸ⡼ΥϼΤȤꡣ
   jfjf : Ѵ⡼ɤ롣
          (see variable `tcode-use-postfix-bushu-as-default')
   00, 01, 10, 11 : ȥɽɽ(01)
   22 : JIS ɰɽˤϡ
   32 : , . ڤؤ롣(see variable `tcode-switch-table-list')
   33 : ɽˤѿʸɤ1Хȡ2Хڤؤ
   44 : ľɽǤɽ롣
   55 : ݥȰ֤ˤʸǤɽ롣
   77 : ݥˤ2ʸѴԤ
   88 : ݥȰ֤ˤʸեȥ(: ̣->)
        ǤϥݥȤľʸѴ롣
   99 : 򤼽Ѵ⡼ɤѴ⡼ɤˤˡ
	󥻥뤹롣ޤإפä
   [1-4]8: ʸꤷƸ򤼽ѴԤ
   [2-4]9: ʸꤷƸ򤼽ѴԤ (Ѹͥ)
   \\[toggle-input-method] : ܸ쥳ɥ⡼ɤȴ롣

Ƶư줿ˤϡ`tcode-ready-hook' ¹Ԥ롣
ޤư٤`tcode-toggle-hook'¹Ԥ롣")

(setq tcode-stroke-file-name (concat tcode-data-directory "ttcode.st"))

(setq eelll-text "EELLLTXT")

(setq tcode-special-prefix-alist
      '(((26 23) "ttc-rtbl" "" "" "" "")
	((23 26) "ttc-ltbl" "" "" "" "")))

;;; ttc-tbl.el ends here
